//
//  QGFilterInputTemplate.h
//  YTest
//
//  Created by Matthew McCowan on 7/17/07.
//  Copyright 2007 Quickgigs, Inc. All rights reserved.
//

#import "QGFoundation.h"
#import "QGFilterInputController.h"
#import "QGAngleInputController.h"
#import "QGImageInputController.h"
#import "QGColorInputController.h"
#import "QGPointInputController.h"
#import "QGSliderInputController.h"
#import "QGRectangleInputController.h"
#import "QGTransformInputController.h"
//#import "QGBooleanInputController.h"


typedef enum _QGInputType {
	QGUnknownInput   = 0,
	QGColorInput     = 1,
	QGImageInput     = 2,
	QGTransformInput = 3,
	QGAngleInput     = 4,
	QGScalarInput    = 5,
	QGPointInput     = 6,
	QG3DPointInput   = 7,
	QGOffsetInput    = 8,
	QGRectangleInput = 9,
	QGBooleanInput   = 10
} QGInputTypeValue;


@interface QGFilterInputTemplate : QGObject
{
	// Instance
	NSDictionary     *attributes;
	NSString         *inputKey;
	QGInputTypeValue  inputType;
}

// Class
+ (NSArray *) inputTemplatesForFilterName:(NSString *)filterName;
+ (NSArray *) inputTemplatesForFilter:(CIFilter *)filter;


// Initialization
- (id) initWithAttributes:(NSDictionary *)initAttributes usingKey:(NSString *)initKey;
- (void) initType;


// Properties
- (NSString *) title;
- (NSString *) key;
- (BOOL) hasController;


// Actions
- (QGFilterInputController *) controllerForOwner:(id)owner;

@end
